--- Lib/ssl.py.orig	2017-03-15 18:55:28.416457954 +0100
+++ Lib/ssl.py	2017-03-15 18:55:40.040629182 +0100
@@ -78,9 +78,11 @@
      SSL_ERROR_WANT_CONNECT, \
      SSL_ERROR_EOF, \
      SSL_ERROR_INVALID_ERROR_CODE
-from _ssl import PROTOCOL_SSLv3, PROTOCOL_SSLv23, PROTOCOL_TLSv1
+from _ssl import PROTOCOL_SSLv3, PROTOCOL_SSLv23, PROTOCOL_TLSv1, PROTOCOL_TLSv1_1, PROTOCOL_TLSv1_2
 _PROTOCOL_NAMES = {
     PROTOCOL_TLSv1: "TLSv1",
+    PROTOCOL_TLSv1_1: "TLSv1_1",
+    PROTOCOL_TLSv1_2: "TLSv1_2",
     PROTOCOL_SSLv23: "SSLv23",
     PROTOCOL_SSLv3: "SSLv3",
 }
--- Modules/_ssl.c.orig	2017-03-15 18:55:36.672575701 +0100
+++ Modules/_ssl.c	2017-03-15 18:55:42.820667427 +0100
@@ -69,7 +69,9 @@
 #endif
     PY_SSL_VERSION_SSL3=1,
     PY_SSL_VERSION_SSL23,
-    PY_SSL_VERSION_TLS1
+    PY_SSL_VERSION_TLS1,
+    PY_SSL_VERSION_TLS11,
+    PY_SSL_VERSION_TLS12
 };
 
 /* Include symbols from _socket module */
@@ -303,6 +305,10 @@
     }
 
     PySSL_BEGIN_ALLOW_THREADS
+    if (proto_version == PY_SSL_VERSION_TLS12)
+        self->ctx = SSL_CTX_new(TLSv1_2_method()); /* Set up context */
+    if (proto_version == PY_SSL_VERSION_TLS11)
+        self->ctx = SSL_CTX_new(TLSv1_1_method()); /* Set up context */
     if (proto_version == PY_SSL_VERSION_TLS1)
         self->ctx = SSL_CTX_new(TLSv1_method()); /* Set up context */
     else if (proto_version == PY_SSL_VERSION_SSL3)
@@ -1818,6 +1824,10 @@
                             PY_SSL_VERSION_SSL23);
     PyModule_AddIntConstant(m, "PROTOCOL_TLSv1",
                             PY_SSL_VERSION_TLS1);
+    PyModule_AddIntConstant(m, "PROTOCOL_TLSv1_1",
+                            PY_SSL_VERSION_TLS11);
+    PyModule_AddIntConstant(m, "PROTOCOL_TLSv1_2",
+                            PY_SSL_VERSION_TLS12);
 
     /* OpenSSL version */
     /* SSLeay() gives us the version of the library linked against,
